
#include <memory.h>
#include <stdio.h>
#include <string.h>

int main(int argc, char** argv)
{
	if(argc < 2)
	{
		printf("usage:  %s <srcfile>\n",argv[0]);
		return 0;
	}

	FILE* file = fopen(argv[1],"rb");
	if(!file)
	{
		printf("Unable to open source file.\n");
		return 0;
	}

	unsigned char* buf = new unsigned char[0x6010];

	fread(buf,1,0x6010,file);
	fclose(file);

	int len = (int)strlen(argv[1]);
	char* fn = new char[len + 50];
	strcpy(fn,argv[1]);
	if((len >= 4) && (!strcmp(fn+len-4,".nes")))		strcpy(fn+len-4,"_expanded.nes");
	else												strcat(fn,"_expanded.nes");

	file = fopen(fn,"wb");
	delete[] fn;
	if(!file)
	{
		printf("Unable to create expanded ROM file.\n");
		delete[] buf;
		return 0;
	}

	static const int bytes = 0xFFFA-0xEA78;
	static const char zeros[0x4000-bytes] = {0};

	buf[0x0004] = 2;		// PRG pages
	buf[0x072E] = 0x80;		// high level pointer
	buf[0x072A] = 0x00;		// low level pointer

	fwrite(buf,1,0x10,file);
	fwrite(&buf[0x2A88],1,bytes,file);
	fwrite(zeros,1,0x4000-bytes,file);
	memset(&buf[0x2A88],0,bytes);
	fwrite(&buf[0x10],1,0x6000,file);
	fclose(file);

	return 0;
}