
#include "graphic.h"
#include "levels.h"

class LodeFrame;
class wxConfigBase;

class LodeApp : public wxApp
{
public:
				LodeApp();
	bool		OnInit();

	int			SavePrompt();
	int			Save();
	int			Load();
	void		Calc();
	void		Dirty() { bIsDirty = 1; }
	Graphic&	Gfx() { return gfx; }
	Levels&		GetLevels() { return levels; }

	int			IsLoaded() { return bFileLoaded; }

	void		SetTile(int tile);

	void		ImportLevel();
	void		ExportLevel();


protected:
	LodeFrame*		wFrame;

	int				bFileLoaded;
	int				bIsDirty;
	wxString		strFilePath;

	Graphic			gfx;
	Levels			levels;

	int			DoCalc();

	int					nMaxBytes;
	int					nStartOffset;


	void			GetConfigOffsets(wxString& fn,long* offsets);
	void			SetConfigOffsets(wxString& fn,long* offsets);
	wxString		GetConfigFileName();
	int				FindConfigFileIndex(wxConfigBase* cfg,wxString& fn);

};


DECLARE_APP(LodeApp);