
#include <wx/wx.h>
#include <wx/stdpaths.h>
#include <wx/filename.h>
#include <wx/fileconf.h>
#include "app.h"

wxString LodeApp::GetConfigFileName()
{
	wxFileName filename(wxStandardPaths::Get().GetExecutablePath());
	filename.SetFullName(wxT("LodeFunner.cfg"));
	return filename.GetFullPath();
}

void LodeApp::GetConfigOffsets(wxString& fn,long* offsets)
{
	offsets[0] = 0x2A88;
	offsets[1] = 0x400A;
	offsets[2] = 0x5610;
	offsets[3] = 0x038E;

	wxString cfgname = GetConfigFileName();
	if(!::wxFileExists(cfgname))
		return;
	
	wxFileConfig cfg(wxEmptyString,wxEmptyString,
		cfgname,wxEmptyString,wxCONFIG_USE_LOCAL_FILE);

	int index = FindConfigFileIndex(&cfg,fn);

	cfg.Read(wxString::Format(wxT("%d_LevStrt"),index),&offsets[0],0x2A88);
	cfg.Read(wxString::Format(wxT("%d_LevStop"),index),&offsets[1],0x400A);
	cfg.Read(wxString::Format(wxT("%d_Graphic"),index),&offsets[2],0x5610);
	cfg.Read(wxString::Format(wxT("%d_Palette"),index),&offsets[3],0x038E);
}

void LodeApp::SetConfigOffsets(wxString& fn,long* offsets)
{
	wxFileConfig cfg(wxEmptyString,wxEmptyString,
		GetConfigFileName(),wxEmptyString,wxCONFIG_USE_LOCAL_FILE);
	
	int index = FindConfigFileIndex(&cfg,fn);

	cfg.Write(wxString::Format(wxT("%d_Path"),index),fn);
	cfg.Write(wxString::Format(wxT("%d_LevStrt"),index),offsets[0]);
	cfg.Write(wxString::Format(wxT("%d_LevStop"),index),offsets[1]);
	cfg.Write(wxString::Format(wxT("%d_Graphic"),index),offsets[2]);
	cfg.Write(wxString::Format(wxT("%d_Palette"),index),offsets[3]);
}

int LodeApp::FindConfigFileIndex(wxConfigBase* cfg,wxString& fn)
{
	wxString tmp;
	int i;
	for(i = 0; i < 999; ++i)
	{
		if(!cfg->Read(wxString::Format(wxT("%d_Path"),i),&tmp))
			break;

		if(tmp == fn)
			break;
	}

	return i;
}
