
#ifndef __LEVELS_H__
#define __LEVELS_H__

typedef unsigned char u8;

struct LEVEL
{
	u8		enemies;
	u8		enX[7];
	u8		enY[7];
	u8		plX;
	u8		plY;
	u8		mp[14][28];
};

class BitPacker
{
public:
	BitPacker(u8* buf,int mxlen);

	u8			Get1();
	u8			Get2();
	u8			Get3();
	u8			Get5();

	void		Set1(u8 v);
	void		Set2(u8 v);
	void		Set3(u8 v);
	void		Set5(u8 v);

	int			GetNumBits() { return (nPos*8)+nBit; }

protected:
	void		IncBit();
	int			nPos;
	int			nMaxLen;
	u8*			pBuf;
	int			nBit;
};

class Levels
{
public:
	Levels();
	~Levels();

	void		Load(u8* buf,int mxlen);
	int			Save(u8* buf,int mxlen);

	u8			Get(int lev,int x,int y);
	void		Set(int lev,int x,int y,int tile,int& alt_x,int& alt_y);

	LEVEL&		Get(int lev) { return lvl[lev]; }

protected:
	void		Zero();
	int			KillEnemy(int lev,int en);
	int			FindBestRowType(int lev,int y,u8* pal);
	void		FillObjectTiles(int lev,int y,int adj);
	LEVEL		lvl[50];
};


#endif
