// -*- C++ -*- generated by wxGlade 0.6.1 on Thu Jan 31 13:02:57 2008

#include <wx/wx.h>
// begin wxGlade: ::dependencies
#include <wx/statline.h>
// end wxGlade

#include "app.h"
#include "lodemap.h"
#include "lodeframe.h"
#include "lodeselwnd.h"
#include "lodetileset.h"

#include "icon.xpm"

// begin wxGlade: ::extracode
// end wxGlade


BEGIN_EVENT_TABLE(LodeFrame, wxFrame)
	EVT_CLOSE(LodeFrame::OnClose)

	EVT_MENU(ID_File_Load,LodeFrame::OnFileLoad)
	EVT_MENU(ID_File_Save,LodeFrame::OnFileSave)
	EVT_MENU(ID_File_Calc,LodeFrame::OnFileCalc)
	EVT_MENU(ID_File_Exit,LodeFrame::OnFileExit)
	
	EVT_MENU(ID_Level_Import,LodeFrame::OnLevelImport)
	EVT_MENU(ID_Level_Export,LodeFrame::OnLevelExport)

	EVT_BUTTON(ID_Btn_PrevLev,LodeFrame::OnPrevLev)
	EVT_BUTTON(ID_Btn_NextLev,LodeFrame::OnNextLev)

	EVT_COMMAND_SCROLL(ID_LevSlider,LodeFrame::OnSlide)
END_EVENT_TABLE()

LodeFrame::LodeFrame(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxFrame(parent, id, title, pos, size, wxDEFAULT_FRAME_STYLE & ~(wxRESIZE_BORDER | wxMAXIMIZE_BOX))
{
	// Menu
    wxMenu* menuFile = new wxMenu;
		menuFile->Append(ID_File_Load,		wxT("L&oad File\tCtrl+O") );
		menuFile->Append(ID_File_Save,		wxT("&Save File\tCtrl+S") );
		menuFile->AppendSeparator();
		menuFile->Append(ID_File_Calc,		wxT("&Calculate Bits Used\tCtrl+C") );
		menuFile->AppendSeparator();
		menuFile->Append(ID_File_Exit,		wxT("E&xit\tCtrl+X") );

	wxMenu* menuLevel = new wxMenu;
		menuLevel->Append(ID_Level_Import,	wxT("&Import Level\tCtrl+I") );
		menuLevel->Append(ID_Level_Export,	wxT("&Export Level\tCtrl+E") );
		
    wxMenuBar* menuBar = new wxMenuBar;
		menuBar->Append( menuFile, wxT("&File") );
		menuBar->Append( menuLevel, wxT("&Level") );
		
    SetMenuBar( menuBar );


    // begin wxGlade: LodeFrame::LodeFrame
    panel_1 = new wxPanel(this, wxID_ANY);
    label_1 = new wxStaticText(panel_1, wxID_ANY, wxT("Editing File:"));
    ctFileName = new wxStaticText(panel_1, wxID_ANY, wxT("No File Loaded"));
    ctLevelText = new wxStaticText(panel_1, wxID_ANY, wxEmptyString);
    btnPrev = new wxButton(panel_1, ID_Btn_PrevLev, wxT("-"));
    ctLevSlider = new wxSlider(panel_1, ID_LevSlider, 0, 0, 10, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL|wxSL_AUTOTICKS|wxSL_TOP);
    btnNext = new wxButton(panel_1, ID_Btn_NextLev, wxT("+"));
    wndMap = new LodeMap(panel_1, wxID_ANY);
    static_line_1 = new wxStaticLine(panel_1, wxID_ANY);
    wndSel = new LodeSelWnd(panel_1, wxID_ANY);
    static_line_2 = new wxStaticLine(panel_1, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_VERTICAL);
    wndTileset = new LodeTileset(panel_1, wxID_ANY);

    set_properties();
    do_layout();
    // end wxGlade

	ctLevSlider->SetRange(0,49);
	ctLevSlider->SetPageSize(5);
	ctLevSlider->SetValue(0);
	ctLevSlider->Enable(0);
	btnPrev->Enable(0);
	btnNext->Enable(0);

	wxIcon icon(LODEICON);
	SetIcon(icon);
}

void LodeFrame::Redraw()
{
	wndMap->SetLevel(nLev);
}

void LodeFrame::FileLoaded(wxString& fn)
{
	ctFileName->SetLabel(fn);
	btnPrev->Enable(1);
	btnNext->Enable(1);
	ctLevSlider->Enable(1);

	wndTileset->Refresh(0,0);

	SetTile(0);

	SetLevel(0,1);
}

void LodeFrame::SetLevel(int lev,int force)
{
	if(!wxGetApp().IsLoaded())
		return;

	if(lev < 0)		lev = 0;
	if(lev > 49)	lev = 49;

	if(!force)
	{
		if(lev == nLev)	return;
	}

	nLev = lev;
    ctLevSlider->SetValue(lev);
	wndMap->SetLevel(lev);

	ctLevelText->SetLabel(wxString::Format(wxT("Editing Level:  %d"),lev+1));
	sizLevText->Layout();
}

void LodeFrame::SetTile(int tile)
{
	nTile = tile;
	wndSel->SetTile(tile);
	wndMap->SetTile(tile);
}


void LodeFrame::set_properties()
{
    // begin wxGlade: LodeFrame::set_properties
    SetTitle(wxT("Lode Funner"));
    // end wxGlade
}


void LodeFrame::do_layout()
{
	sizLevText = new wxBoxSizer(wxVERTICAL);
    // begin wxGlade: LodeFrame::do_layout
    wxBoxSizer* sizer_1 = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_2 = sizLevText;
    wxBoxSizer* sizer_7 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* sizer_6 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* sizer_3 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* sizer_5 = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_4 = new wxBoxSizer(wxVERTICAL);
    sizer_4->Add(label_1, 0, wxALIGN_RIGHT, 0);
    sizer_3->Add(sizer_4, 0, wxEXPAND, 0);
    sizer_5->Add(ctFileName, 0, wxEXPAND, 0);
    sizer_3->Add(sizer_5, 1, wxEXPAND|wxLEFT, 8);
    sizer_2->Add(sizer_3, 0, wxLEFT|wxRIGHT|wxTOP|wxEXPAND, 8);
    sizer_2->Add(ctLevelText, 0, wxLEFT|wxRIGHT|wxTOP|wxALIGN_CENTER_HORIZONTAL, 8);
    sizer_6->Add(btnPrev, 0, wxRIGHT, 4);
    sizer_6->Add(ctLevSlider, 1, wxEXPAND, 0);
    sizer_6->Add(btnNext, 0, wxLEFT, 4);
    sizer_2->Add(sizer_6, 0, wxLEFT|wxRIGHT|wxTOP|wxEXPAND, 8);
    sizer_2->Add(wndMap, 0, wxLEFT|wxRIGHT, 8);
    sizer_2->Add(static_line_1, 0, wxALL|wxEXPAND, 8);
    sizer_7->Add(wndSel, 0, 0, 0);
    sizer_7->Add(static_line_2, 0, wxLEFT|wxRIGHT|wxEXPAND, 8);
    sizer_7->Add(wndTileset, 0, 0, 0);
    sizer_2->Add(sizer_7, 0, wxLEFT|wxRIGHT|wxBOTTOM|wxALIGN_CENTER, 8);
    panel_1->SetSizer(sizer_2);
    sizer_1->Add(panel_1, 1, wxEXPAND, 0);
    SetSizer(sizer_1);
    sizer_1->Fit(this);
    Layout();
    // end wxGlade
}

void LodeFrame::OnClose(wxCloseEvent& event)
{
	if(!event.CanVeto())
	{
		Destroy();
	}
	else
	{
		if(wxGetApp().SavePrompt())
			event.Veto();
		else
			Destroy();
	}
}

void LodeFrame::OnFileExit(wxCommandEvent& event)
{
	Close();
}

void LodeFrame::OnFileSave(wxCommandEvent& event)
{
	wxGetApp().Save();
}

void LodeFrame::OnFileCalc(wxCommandEvent& event)
{
	wxGetApp().Calc();
}

void LodeFrame::OnFileLoad(wxCommandEvent& event)
{
	wxGetApp().Load();
}

void LodeFrame::OnPrevLev(wxCommandEvent& event)
{
	SetLevel(nLev - 1);
}

void LodeFrame::OnNextLev(wxCommandEvent& event)
{
	SetLevel(nLev + 1);
}

void LodeFrame::OnSlide(wxScrollEvent& event)
{
	SetLevel(event.GetPosition());
}

void LodeFrame::OnLevelImport(wxCommandEvent& event)
{
	wxGetApp().ImportLevel();
}

void LodeFrame::OnLevelExport(wxCommandEvent& event)
{
	wxGetApp().ExportLevel();
}