
#include <wx/wx.h>
#include <wx/settings.h>
#include <wx/brush.h>
#include <wx/dcbuffer.h>
#include "app.h"
#include "lodeselwnd.h"


BEGIN_EVENT_TABLE(LodeSelWnd, wxWindow)
	EVT_PAINT(LodeSelWnd::OnPaint)
END_EVENT_TABLE()

LodeSelWnd::LodeSelWnd(wxWindow* parent, int id)
	: wxWindow(parent,id,wxDefaultPosition,wxDefaultSize,wxBORDER_SUNKEN)
{
	SetBackgroundStyle(wxBG_STYLE_CUSTOM);
	SetClientSize(32,32);
	nTile = 0;
}

void LodeSelWnd::OnPaint(wxPaintEvent& event)
{
	wxAutoBufferedPaintDC dc(this);

	if(wxGetApp().IsLoaded())
	{
		wxGetApp().Gfx().DrawTile(nTile,&dc,0,0,1);
	}
	else
	{
		wxBrush br(wxSystemSettings::GetColour(wxSYS_COLOUR_APPWORKSPACE));

		dc.SetBackground(br);
		dc.Clear();
		dc.SetBackground(wxNullBrush);
	}
}

void LodeSelWnd::SetTile(int tile)
{
	nTile = tile;
	Refresh(0,0);
}