
#include <wx/wx.h>
#include <wx/settings.h>
#include <wx/brush.h>
#include <wx/dcbuffer.h>
#include "app.h"
#include "lodetileset.h"


BEGIN_EVENT_TABLE(LodeTileset, wxWindow)
	EVT_PAINT(LodeTileset::OnPaint)
	EVT_LEFT_DOWN(LodeTileset::OnLDown)
	EVT_RIGHT_DOWN(LodeTileset::OnLDown)
END_EVENT_TABLE()

LodeTileset::LodeTileset(wxWindow* parent, int id)
	: wxWindow(parent,id,wxDefaultPosition,wxDefaultSize,wxBORDER_SUNKEN)
{
	SetBackgroundStyle(wxBG_STYLE_CUSTOM);
	SetClientSize(32 * 10,32);
}

void LodeTileset::OnPaint(wxPaintEvent& event)
{
	wxAutoBufferedPaintDC dc(this);

	if(wxGetApp().IsLoaded())
	{
		int i;
		for(i = 0; i < 10; ++i)
			wxGetApp().Gfx().DrawTile(i,&dc,i,0,1);
	}
	else
	{
		wxBrush br(wxSystemSettings::GetColour(wxSYS_COLOUR_APPWORKSPACE));

		dc.SetBackground(br);
		dc.Clear();
		dc.SetBackground(wxNullBrush);
	}
}

void LodeTileset::OnLDown(wxMouseEvent& event)
{
	int tile = event.GetX() / 32;
	if((tile < 0) || (tile > 9))
		tile = 0;

	wxGetApp().SetTile(tile);
}